Name:		imsettings
Version:	0.108.0
Release:	3.6%{?dist}
License:	LGPLv2+
URL:		http://code.google.com/p/imsettings/
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildRequires:	desktop-file-utils
BuildRequires:	intltool gettext
BuildRequires:	libtool automake autoconf
BuildRequires:	dbus-devel >= 0.23, dbus-glib-devel >= 0.74, glib2 >= 2.16
BuildRequires:	libgxim-devel >= 0.3.1, libnotify-devel
%if !0%{?rhel}
BuildRequires:	xfconf-devel
%endif
BuildRequires:	GConf2-devel
BuildRequires:	libX11-devel
Source0:	http://imsettings.googlecode.com/files/%{name}-%{version}.tar.bz2
# workaround for KDE, it will be removed when we have a correct fix
Source1: 	imsettings-kde.sh
Patch0:		imsettings-constraint-of-language.patch
Patch1:		imsettings-disable-xim.patch
Patch2:		imsettings-xinput-xcompose.patch
Patch3:		imsettings-fix-lxde-fail.patch
Patch4:		imsettings-no-restart-with-exit0.patch
Patch5:		imsettings-translation-updates.patch
Patch6:		imsettings-fix-race-on-popen.patch
Patch7:		imsettings-translation-updates2.patch
Patch8:		imsettings-713433-mem-corrupt.patch

Summary:	Delivery framework for general Input Method configuration
Group:		Applications/System
Requires:	xorg-x11-xinit >= 1.0.2-22.fc8
Requires:	imsettings-libs = %{version}-%{release}
Requires(pre):	GConf2
Requires(post):	/bin/dbus-send %{_sbindir}/alternatives GConf2
Requires(preun):	GConf2
Requires(postun):	/bin/dbus-send %{_sbindir}/alternatives

%description
IMSettings is a framework that delivers Input Method
settings and applies the changes so they take effect
immediately without any need to restart applications
or the desktop.

This package contains the core DBus services and some utilities.

%package	libs
Summary:	Libraries for imsettings
Group:		Development/Libraries

%description	libs
IMSettings is a framework that delivers Input Method
settings and applies the changes so they take effect
immediately without any need to restart applications
or the desktop.

This package contains the shared library for imsettings.

%package	devel
Summary:	Development files for imsettings
Group:		Development/Libraries
Requires:	%{name}-libs = %{version}-%{release}
Requires:	pkgconfig
Requires:	glib2-devel >= 2.16.0
Requires:	dbus-glib-devel >= 0.74

%description	devel
IMSettings is a framework that delivers Input Method
settings and applies the changes so they take effect
immediately without any need to restart applications
or the desktop.

This package contains the development files to make any
applications with imsettings.

%if !0%{?rhel}
%package	xfce
Summary:	Xfce support on imsettings
Group:		Applications/System
Requires:	%{name} = %{version}-%{release}
Requires:	im-chooser
Requires:	xfce4-settings >= 4.5.99.1-2

%description	xfce
IMSettings is a framework that delivers Input Method
settings and applies the changes so they take effect
immediately without any need to restart applications
or the desktop.

This package contains a plugin to get this working on Xfce.  

%package	lxde
Summary:	LXDE support on imsettings
Group:		Applications/System
Requires:	%{name} = %{version}-%{release}
Requires:	lxde-settings-daemon

%description	lxde
IMSettings is a framework that delivers Input Method
settings and applies the changes so they take effect
immediately without any need to restart applications
or the desktop.

This package contains a helper program to get this working on LXDE.
%endif

%prep
%setup -q
%patch0 -p1 -b .0-lang
%patch1 -p1 -b .1-xim
%patch2 -p1 -b .2-xcompose
%patch3 -p0 -b .3-lxde
%patch4 -p0 -b .4-no-restart
%patch5 -p0 -b .5-translations
%patch6 -p0 -b .6-popen
%patch7 -p2 -b .7-translations2
%patch8 -p1 -b .8-mem-currupt
autoreconf -Im4macros -f

%build
%configure	\
	--with-xinputsh=50-xinput.sh \
	--disable-static \
	--disable-schemas-install

make %{?_smp_mflags}


%install
rm -rf $RPM_BUILD_ROOT
make install DESTDIR=$RPM_BUILD_ROOT

# change the file attributes
chmod 0755 $RPM_BUILD_ROOT%{_libexecdir}/xinputinfo.sh
chmod 0755 $RPM_BUILD_ROOT%{_sysconfdir}/X11/xinit/xinitrc.d/50-xinput.sh

# clean up the unnecessary files
rm -f $RPM_BUILD_ROOT%{_libdir}/*.la
rm -f $RPM_BUILD_ROOT%{_libdir}/xfce4/mcs-plugins/*.la
%if 0%{?rhel}
rm -f $RPM_BUILD_ROOT%{_sysconfdir}/xdg/autostart/imsettings-xfce-helper.desktop
rm -f $RPM_BUILD_ROOT%{_bindir}/imsettings-xfce-helper
rm -f $RPM_BUILD_ROOT%{_sysconfdir}/xdg/autostart/imsettings-lxde-helper.desktop
rm -f $RPM_BUILD_ROOT%{_bindir}/imsettings-lxde-helper
%endif

# still not stable
rm -f $RPM_BUILD_ROOT%{_datadir}/dbus-1/services/qt-im-settings-daemon.service
rm -f $RPM_BUILD_ROOT%{_libexecdir}/qt-im-settings-daemon

# workaround for KDE
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/kde/env
install -m 644 %{SOURCE1} $RPM_BUILD_ROOT%{_sysconfdir}/kde/env/

# disable running applet by default
rm -f $RPM_BUILD_ROOT%{_sysconfdir}/xdg/autostart/imsettings-applet.desktop

#desktop-file-install						\
#	--delete-original					\
#	--dir=$RPM_BUILD_ROOT%{_sysconfdir}/xdg/autostart	\
#	$RPM_BUILD_ROOT%{_sysconfdir}/xdg/autostart/imsettings-applet.desktop

%find_lang %{name}

%clean
rm -rf $RPM_BUILD_ROOT


%pre
if [ "$1" -gt 1 ]; then
	export GCONF_CONFIG_SOURCE=`gconftool-2 --get-default-source`
	if [ -f %{_sysconfdir}/gconf/schemas/imsettings-applet.schemas ]; then
		gconftool-2 --makefile-uninstall-rule %{_sysconfdir}/gconf/schemas/imsettings-applet.schemas > /dev/null || :
	fi
fi

%post
export GCONF_CONFIG_SOURCE=`gconftool-2 --get-default-source`
gconftool-2 --makefile-install-rule %{_sysconfdir}/gconf/schemas/imsettings-applet.schemas > /dev/null || :
alternatives --install %{_sysconfdir}/X11/xinit/xinputrc xinputrc %{_sysconfdir}/X11/xinit/xinput.d/none.conf 10
alternatives --install %{_sysconfdir}/X11/xinit/xinputrc xinputrc %{_sysconfdir}/X11/xinit/xinput.d/xim.conf 30
dbus-send --system --type=method_call --dest=org.freedesktop.DBus / org.freedesktop.DBus.ReloadConfig > /dev/null 2>&1 || :

%preun
if [ "$1" -eq 0 ]; then
	export GCONF_CONFIG_SOURCE=`gconftool-2 --get-default-source`
	gconftool-2 --makefile-uninstall-rule %{_sysconfdir}/gconf/schemas/imsettings-applet.schemas > /dev/null || :
fi

%postun
if [ "$1" = 0 ]; then
	alternatives --remove xinputrc %{_sysconfdir}/X11/xinit/xinput.d/none.conf
	alternatives --remove xinputrc %{_sysconfdir}/X11/xinit/xinput.d/xim.conf
	dbus-send --system --type=method_call --dest=org.freedesktop.DBus / org.freedesktop.DBus.ReloadConfig > /dev/null 2>&1 || :
fi

%post libs -p /sbin/ldconfig
%postun libs -p /sbin/ldconfig

%files	-f %{name}.lang
%defattr(-, root, root, -)
%doc AUTHORS COPYING ChangeLog NEWS README
%{_bindir}/imsettings-applet
%{_bindir}/imsettings-info
%{_bindir}/imsettings-list
%{_bindir}/imsettings-reload
%{_bindir}/imsettings-restart
%{_bindir}/imsettings-start
%{_bindir}/imsettings-stop
%{_bindir}/imsettings-xim
%{_libexecdir}/gconf-im-settings-daemon
%{_libexecdir}/im-settings-daemon
%{_libexecdir}/xinputinfo.sh
%{_datadir}/dbus-1/services/*.service
%{_datadir}/pixmaps/*.png
%{_sysconfdir}/X11/xinit/xinitrc.d/50-xinput.sh
%{_sysconfdir}/X11/xinit/xinput.d
%{_sysconfdir}/xdg/autostart/imsettings-start.desktop
%{_sysconfdir}/gconf/schemas/imsettings-applet.schemas
%{_sysconfdir}/kde/env/*.sh

%files	libs
%defattr(-, root, root, -)
%doc AUTHORS COPYING ChangeLog NEWS README
%{_libdir}/libimsettings.so.*
%{_libdir}/libimsettings-xim.so.*

%files	devel
%defattr(-, root, root, -)
%doc AUTHORS COPYING ChangeLog NEWS README
%{_includedir}/imsettings
%{_libdir}/libimsettings.so
%{_libdir}/libimsettings-xim.so
%{_libdir}/pkgconfig/imsettings.pc

%if !0%{?rhel}
%files	xfce
%defattr(-, root, root, -)
%doc AUTHORS COPYING ChangeLog NEWS README
%{_bindir}/imsettings-xfce-helper
%{_sysconfdir}/xdg/autostart/imsettings-xfce-helper.desktop

%files	lxde
%defattr(-, root, root, -)
%doc AUTHORS COPYING ChangeLog NEWS README
%{_bindir}/imsettings-lxde-helper
%{_sysconfdir}/xdg/autostart/imsettings-lxde-helper.desktop
%endif



%changelog

